<template>
  <div id="container">
    <div class="row">
      <div class="col-3">
        <input
          v-model="searchValue"
          type="text"
          class="form-control"
          placeholder="Search Project Title.."
          @keyup="filtersChanged($event)"
        />
      </div>
      <div class="col-4">
        <multiselect
          id="select1"
          v-model="statusSelection"
          :options="statuses"
          :multiple="true"
          :searchable="false"
          :close-on-select="false"
          :clear-on-select="false"
          placeholder="Select statuses"
          @input="filtersChanged($event)"
        >
        </multiselect>
      </div>
      <div class="col-5 display-inline">
        <multiselect
          id="select2"
          v-model="datasetsSelection"
          class="dataset-multiselect"
          :options="datasets"
          :multiple="true"
          :searchable="false"
          :close-on-select="false"
          :clear-on-select="false"
          label="label"
          track-by="id"
          placeholder="Select datasets"
          @input="filtersChanged($event)"
        >
        </multiselect>
        <b-button v-if="showExportButton" type="button" @click="exportAll()"
          >Export all</b-button
        >
      </div>
    </div>
    <div class="card">
      <table class="table">
        <tr>
          <th>ID</th>
          <th>Dataset(s)</th>
          <th>Applicant</th>
          <th>Project Title</th>
          <th>Created At</th>
          <th>Status</th>
          <th></th>
        </tr>
        <tbody>
          <tr v-for="ar in accessRequestsFiltered" :key="ar.id">
            <td>{{ ar.id }}</td>
            <td>
              <div v-for="dataset in ar.datasets" :key="dataset.id">
                <span>
                  - {{ dataset.dataset.label }}
                  <span
                    v-if="ar.step === 4 && dataset.decision === 0"
                    class="red"
                    title="This dataset was declined by its access manager"
                    ><XIcon />
                  </span>
                </span>
                <br />
              </div>
            </td>
            <td>{{ ar.user.first_name + ' ' + ar.user.last_name }} <br /></td>

            <td>
              <span :title="ar.project_title">
                {{
                  ar?.project_title.length > 30
                    ? ar.project_title.slice(0, 28) + '...'
                    : ar.project_title
                }}
              </span>
            </td>
            <td>
              {{
                new Date(ar.created_at).toLocaleString('en-UK', {
                  timeStyle: 'short',
                  dateStyle: 'medium',
                })
              }}
            </td>
            <td>
              <span v-if="ar.status" :title="ar.status">
                {{
                  ar?.status.length > 15
                    ? ar.status.slice(0, 10) + '...'
                    : ar.status
                }}
              </span>
            </td>
            <td>
              <a
                class="btn mr-1m rimow-step-by-step-guide mode-simple toggle-mode-visible visible cursor-pointer"
                :href="`/access-request/${ar.id}/details`"
                >Details</a
              >
              <b-button
                v-if="showEvaluationButton && ar.showEvaluationButton"
                :href="`/access-request/${ar.id}/evaluation`"
                >Evaluate
              </b-button>
            </td>
          </tr>
        </tbody>
      </table>
      <div v-if="accessRequests.length && !accessRequestsFiltered.length">
        <span class="empty-message">
          No access requests available with these filters</span
        >
      </div>
      <div v-if="!accessRequests.length">
        <span class="empty-message">No access requests</span>
      </div>
    </div>
  </div>
</template>
<script>
import Multiselect from 'vue-multiselect';

export default {
  components: { Multiselect },
  props: {
    accessRequests: {
      type: Array,
      required: true,
    },
    showEvaluationButton: {
      type: Boolean,
      default: false,
    },
    showExportButton: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      statuses: [],
      statusSelection: [],
      accessRequestsFiltered: [],
      searchValue: '',
      datasets: [],
      datasetsSelection: [],
    };
  },
  async mounted() {
    function parseJwt(token) {
      return JSON.parse(Buffer.from(token.split('.')[1], 'base64').toString());
    }

    const token = this.$auth.strategy.token.get().split(' ');
    const parsedToken = parseJwt(token[1]);
    const userEmail = parsedToken.email;
    this.roles = parsedToken.realm_access.roles;
    this.statuses = this.accessRequests
      .map((request) => request.status || 'undefined')
      .filter((item, i, ar) => ar.indexOf(item) === i);

    this.accessRequests.forEach((ar) => {
      let showEvaluationButton = true;

      if (ar.step === 0) {
        showEvaluationButton = false;
      }

      if (
        ar.status !== 'Pending' &&
        ar.status !== 'Pending evaluation from me'
      ) {
        showEvaluationButton = false;
      }

      if (ar.step === 2 && !this.hasRole('PC')) {
        showEvaluationButton = false;
      }

      if (ar.datasets && ar.step === 1 && !ar.decision_am) {
        const mainDataset = ar.datasets.find((d) => d.is_main === 1);
        if (
          mainDataset &&
          !mainDataset.dataset.access_managers
            .map((a) => a.user_email)
            .includes(userEmail)
        ) {
          showEvaluationButton = false;
        }
      }

      if (ar.step === 1 && ar.decision_am) {
        const secondaryDatasets = ar.datasets.filter((d) => {
          return (
            d.is_main === 0 &&
            d.decision == null &&
            d.is_cancelled === 0 &&
            d.dataset.access_managers
              .map((a) => a.user_email)
              .includes(userEmail)
          );
        });
        if (secondaryDatasets.length === 0) {
          showEvaluationButton = false;
        }
      }

      ar.showEvaluationButton = showEvaluationButton;
      if (showEvaluationButton && this.showEvaluationButton) {
        ar.status = 'Pending evaluation from me';
      }
    });
    this.accessRequestsFiltered = this.accessRequests;
    if (this.showEvaluationButton) {
      this.statuses.push('Pending evaluation from me');
      this.statusSelection = ['Pending evaluation from me'];
      this.filtersChanged();
    }

    this.statuses = [...new Set(this.statuses)];
    this.datasets = await this.$nuxt.context.store.dispatch(
      'access_request/fetchDatasets'
    );
  },
  methods: {
    hasRole(role) {
      return this.roles && this.roles.includes(role);
    },
    filtersChanged() {
      this.accessRequestsFiltered = [];
      this.accessRequests.forEach((ar) => {
        let add = true;

        if (this.statusSelection.length) {
          if (!this.statusSelection.includes(ar.status)) {
            add = false;
          }
        }

        if (this.searchValue) {
          if (
            !ar.project_title
              .toLowerCase()
              .includes(this.searchValue.toLowerCase())
          ) {
            add = false;
          }
        }

        if (this.datasetsSelection.length) {
          const arDatasets = ar.datasets.map((dataset) => dataset.dataset.id);
          const hasDataset = this.datasetsSelection.some((d) =>
            arDatasets.includes(d.id)
          );
          if (!hasDataset) {
            add = false;
          }
        }

        if (add) {
          this.accessRequestsFiltered.push(ar);
        }
      });
    },
    formatStringForCsv(str) {
      return (str + '').replace(/(\r\n|\n|\r)/gm, '');
    },
    exportAll() {
      const columns = [
        'ID',
        'Project Title',
        'Project Acronym',
        'Applicant',
        'Applicant Email',
        'Project Objectives',
        'Project Summary',
        'Data Needed',
        'Access Type',
        'Host Location',
        'Preferred Visit Dates',
        'Is main',
        'Dataset',
        'First question AM',
        'Second question AM',
        'Third question AM',
        'Fourth question AM',
        'Reasoning AM',
        'AM Decision',
        'First question PRB',
        'Second question PRB',
        'Third question PRB',
        'Fourth question PRB',
        'Reasoning PRB',
        'PRB Decision',
        'PC Decision',
        'Created at',
        'Status',
      ];
      const rows = [];
      this.accessRequests.forEach((ar) => {
        let status = 'Pending';
        if (ar.step === 4 && ar.decision_pc === 'Positive') {
          status = 'Positive Decision';
        }

        if (ar.decision_pc === 'Negative' || ar.decision_am === 'Negative') {
          status = 'Negative Decision';
        }

        if (ar.cancelled === 1) {
          status = 'Cancelled by Applicant';
        }

        if (ar.decision_am === 'Revise') {
          status = 'In Revision';
        }

        ar.datasets.forEach((dataset) => {
          rows.push([
            ar.id,
            ar.project_title,
            ar.project_acronym,
            ar.user.first_name + ' ' + ar.user.last_name,
            ar.user.email,
            ar.project_objectives,
            ar.project_summary,
            ar.data_needed,
            dataset.access_type,
            dataset.host_location,
            dataset.preferred_visit_dates,
            dataset.is_main,
            dataset.dataset.label,
            ar.first_question_am ?? '',
            ar.second_question_am ?? '',
            ar.third_question_am ?? '',
            ar.forth_question_am ?? '',
            ar.reasoning_am ?? '',
            ar.decision === 1
              ? 'Positive'
              : ar.decision === 0
              ? 'Negative'
              : 'Pending',
            ar.first_question_prb ?? '',
            ar.second_question_prb ?? '',
            ar.third_question_prb ?? '',
            ar.forth_question_prb ?? '',
            ar.reasoning_prb ?? '',
            ar.decision_prb ?? '',
            ar.decision_pc ?? '',
            ar.created_at,
            status,
          ]);
        });
      });
      let str = columns.join(';');
      rows.forEach((row) => {
        row = row.map((val) => {
          val = this.formatStringForCsv(val);
          return '"' + val + '"';
        });
        str += '\n' + row.join(';');
      });
      const blob = new Blob([str], { type: 'text/csv' });
      const url = window.URL.createObjectURL(blob);
      const a = document.createElement('a');
      a.setAttribute('href', url);
      a.setAttribute('download', 'RCF_Access_Requests.csv');
      a.click();
    },
  },
};
</script>
<style scoped src="vue-multiselect/dist/vue-multiselect.min.css"></style>

<style scoped>
table tr td {
  vertical-align: top;
  padding: 5px;
}

ul li {
  list-style-type: none;
}

.card {
  margin-top: 10px;
}

.green {
  color: green;
  font-weight: bold;
}

.red {
  color: red;
  font-weight: bold;
}

.empty-message {
  padding: 10px;
  margin: 0 auto;
}

.display-inline {
  display: flex;
}

.dataset-multiselect {
  margin-right: 10px;
}
</style>
